/**
 * the class is defined with the export keyword to make it usable outside of the current file
 */
export class Car {
  // define the fields
  // setting them to private to prevent access from outside
  private manufacturer: string = '';
  private model: string = '';

  // in typescript constructors are defined with the keyword constructor
  public constructor(manufacturer: string, model: string) {
    // set manufacturer and model of the current object to the given parameters
    this.manufacturer = manufacturer;
    this.model = model;
  }

  // define the method print_info
  print_info() {
    console.log('Car Information:');
    console.log(`- manufacturer: ${this.manufacturer}`);
    console.log(`- model: ${this.model}`);
  }
}
